Ticket #961 (closed Defect: fixed)

Opened 6 years ago

Last modified 5 years ago

IllegalState: The topic is not identified by ID but by URI

Reported by: Malte Owned by:
Priority: Major Milestone: Release 4.8.3
Component: DeepaMehta Standard Distribution Version: 4.8
Keywords: Cc: jri
Complexity: 3 Area:
Module: deepamehta-core

Description

When running the following in my Migration:

Association assoc = dm4.createAssociation(mf.newAssociationModel("dm4.core.association",
    mf.newTopicRoleModel(pluginTopic.getId(), "dm4.core.default"),
    mf.newTopicRoleModel("org.deepamehta.signup.default_configuration", "dm4.core.default")
));

Which is, creating an Association between two topics but through passing the Topic ID for one (Topic 1) and the Topic URI for the other one (Topic 2). Now, when installing my plugin from scratch with the new 4.8 release i got the following exception:

INFORMATION: ========== Starting plugin "DeepaMehta 4 Sign up" ==========
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl readConfigFile
INFORMATION: Reading config file "/plugin.properties" for plugin "DeepaMehta 4 Sign up"
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl pluginDependencies
INFORMATION: Tracking 3 plugins for plugin "DeepaMehta 4 Sign up" [de.deepamehta.accesscontrol, de.deepamehta.workspaces, de.deepamehta.contacts]
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl createInjectedServiceTrackers
INFORMATION: Tracking 2 services for plugin "DeepaMehta 4 Sign up" [de.deepamehta.accesscontrol.AccessControlService, de.deepamehta.workspaces.WorkspacesService]
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl addService
INFORMATION: Adding DeepaMehta 4 core service to plugin "DeepaMehta 4 Sign up"
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl publishWebResources
INFORMATION: Publishing web resources of plugin "DeepaMehta 4 Sign up" at URI namespace "/org.deepamehta.sign-up"
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl publishRestResources
INFORMATION: Publishing REST resources of plugin "DeepaMehta 4 Sign up" at URI namespace "/sign-up"
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl publishRestResources
INFORMATION: Registering provider classes of plugin "DeepaMehta 4 Sign up" ABORTED -- no provider classes provided
Apr 19, 2016 12:54:01 AM com.sun.jersey.server.impl.application.WebApplicationImpl _initiate
INFORMATION: Initiating Jersey application, version 'Jersey: 1.14 09/09/2012 05:39 PM'
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl addService
INFORMATION: Adding Event Admin service to plugin "DeepaMehta 4 Sign up"
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl addService
INFORMATION: Adding de.deepamehta.accesscontrol.AccessControlService to plugin "DeepaMehta 4 Sign up"
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl addService
INFORMATION: Adding de.deepamehta.workspaces.WorkspacesService to plugin "DeepaMehta 4 Sign up"
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl activate
INFORMATION: ----- Activating plugin "DeepaMehta 4 Sign up" -----
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl createPluginTopicIfNotExists
INFORMATION: Installing plugin "DeepaMehta 4 Sign up" in the database
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.MigrationManager runPluginMigrations
INFORMATION: Running 7 migrations for plugin "DeepaMehta 4 Sign up" (installed model: version 0, required model: version 7)
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.MigrationManager$MigrationInfo readMigrationConfigFile
INFORMATION: Reading migration config file "/migrations/migration1.properties" ABORTED -- file does not exist
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.MigrationManager runMigration
INFORMATION: Running migration 1 of plugin "DeepaMehta 4 Sign up" (runMode=ALWAYS, isCleanInstall=true)
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.MigrationManager readMigrationFile
INFORMATION: Reading migration file "/migrations/migration1.json"
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.MigrationManager runMigration
INFORMATION: Updating installed model: version 1
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.DeepaMehtaObjectModelImpl update
INFORMATION: Updating topic 5804 (typeUri="dm4.core.plugin")
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.DeepaMehtaObjectModelImpl update
INFORMATION: Updating related topic 5815 (typeUri="dm4.core.plugin_migration_nr")
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.DeepaMehtaObjectModelImpl _updateSimpleValue
INFORMATION: ### Changing simple value of related topic 5815 from "0" -> "1"
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.DeepaMehtaObjectModelImpl update
INFORMATION: Updating association 5818 (typeUri="dm4.core.composition")
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.MigrationManager$MigrationInfo readMigrationConfigFile
INFORMATION: Reading migration config file "/migrations/migration2.properties" ABORTED -- file does not exist
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.MigrationManager runMigration
INFORMATION: Running migration 2 of plugin "DeepaMehta 4 Sign up" (runMode=ALWAYS, isCleanInstall=true)
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.MigrationManager injectServices
INFORMATION: Injecting service de.deepamehta.workspaces.WorkspacesService into migration 2 of plugin "DeepaMehta 4 Sign up"
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.MigrationManager runMigration
INFORMATION: Running plugin migration class org.deepamehta.plugins.signup.migrations.Migration2
Apr 19, 2016 12:54:01 AM org.deepamehta.plugins.signup.migrations.Migration2 run
INFORMATION: Sign-up => Assigning default "Sign-up Configuration" to "DeepaMehta 4 Sign up" Topic
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl installPluginInDB
WARNUNG: ROLLBACK! (plugin "DeepaMehta 4 Sign up")
Apr 19, 2016 12:54:01 AM de.deepamehta.core.impl.PluginImpl$1 addingService
SCHWERWIEGEND: An error occurred while adding service de.deepamehta.workspaces.WorkspacesService to plugin "DeepaMehta 4 Sign up":
java.lang.RuntimeException: Activation of plugin "DeepaMehta 4 Sign up" failed
	at de.deepamehta.core.impl.PluginImpl.activate(PluginImpl.java:500)
	at de.deepamehta.core.impl.PluginManager.activatePlugin(PluginManager.java:64)
	at de.deepamehta.core.impl.PluginImpl.checkRequirementsForActivation(PluginImpl.java:464)
	at de.deepamehta.core.impl.PluginImpl.addService(PluginImpl.java:422)
	at de.deepamehta.core.impl.PluginImpl.access$000(PluginImpl.java:45)
	at de.deepamehta.core.impl.PluginImpl$1.addingService(PluginImpl.java:366)
	at org.osgi.util.tracker.ServiceTracker$Tracked.customizerAdding(ServiceTracker.java:932)
	at org.osgi.util.tracker.ServiceTracker$Tracked.customizerAdding(ServiceTracker.java:864)
	at org.osgi.util.tracker.AbstractTracked.trackAdding(AbstractTracked.java:256)
	at org.osgi.util.tracker.AbstractTracked.trackInitial(AbstractTracked.java:183)
	at org.osgi.util.tracker.ServiceTracker.open(ServiceTracker.java:317)
	at org.osgi.util.tracker.ServiceTracker.open(ServiceTracker.java:261)
	at de.deepamehta.core.impl.PluginImpl.openServiceTrackers(PluginImpl.java:395)
	at de.deepamehta.core.impl.PluginImpl.start(PluginImpl.java:120)
	at de.deepamehta.core.osgi.PluginActivator.start(PluginActivator.java:56)
	at org.apache.felix.framework.util.SecureAction.startActivator(SecureAction.java:645)
	at org.apache.felix.framework.Felix.activateBundle(Felix.java:2154)
	at org.apache.felix.framework.Felix.startBundle(Felix.java:2072)
	at org.apache.felix.framework.BundleImpl.start(BundleImpl.java:976)
	at org.apache.felix.fileinstall.internal.DirectoryWatcher.process(DirectoryWatcher.java:1175)
	at org.apache.felix.fileinstall.internal.DirectoryWatcher.process(DirectoryWatcher.java:1153)
	at org.apache.felix.fileinstall.internal.DirectoryWatcher.process(DirectoryWatcher.java:458)
	at org.apache.felix.fileinstall.internal.DirectoryWatcher.run(DirectoryWatcher.java:263)
Caused by: java.lang.RuntimeException: Installing plugin "DeepaMehta 4 Sign up" in the database failed
	at de.deepamehta.core.impl.PluginImpl.installPluginInDB(PluginImpl.java:535)
	at de.deepamehta.core.impl.PluginImpl.activate(PluginImpl.java:487)
	... 22 more
Caused by: java.lang.RuntimeException: Running migration 2 of plugin "DeepaMehta 4 Sign up" failed
	at de.deepamehta.core.impl.MigrationManager.runMigration(MigrationManager.java:147)
	at de.deepamehta.core.impl.MigrationManager.runPluginMigration(MigrationManager.java:103)
	at de.deepamehta.core.impl.MigrationManager.runPluginMigrations(MigrationManager.java:70)
	at de.deepamehta.core.impl.PluginImpl.installPluginInDB(PluginImpl.java:525)
	... 23 more
Caused by: java.lang.RuntimeException: Creating association failed (association (id=-1, uri="null", typeUri="dm4.core.association", value="null", childTopics={}, 
        topic role (roleTypeUri="dm4.core.default", playerId=5804), 
        topic role (roleTypeUri="dm4.core.default", topicUri="org.deepamehta.signup.default_configuration")))
	at de.deepamehta.core.impl.PersistenceLayer.createAssociation(PersistenceLayer.java:302)
	at de.deepamehta.core.impl.CoreServiceImpl.createAssociation(CoreServiceImpl.java:196)
	at org.deepamehta.plugins.signup.migrations.Migration2.run(Migration2.java:33)
	at de.deepamehta.core.impl.MigrationManager.runMigration(MigrationManager.java:140)
	... 26 more
Caused by: java.lang.RuntimeException: An error occurred in the PreCreateAssociationListener of plugin "DeepaMehta 4 Contacts"
	at de.deepamehta.core.impl.EventManager.dispatchEvent(EventManager.java:96)
	at de.deepamehta.core.impl.EventManager.fireEvent(EventManager.java:59)
	at de.deepamehta.core.impl.PersistenceLayer.createAssociation(PersistenceLayer.java:290)
	... 29 more
Caused by: java.lang.IllegalStateException: The topic is not identified by ID but by URI (
        topic role (roleTypeUri="dm4.core.default", topicUri="org.deepamehta.signup.default_configuration"))
	at de.deepamehta.core.impl.TopicRoleModelImpl.getPlayerId(TopicRoleModelImpl.java:39)
	at de.deepamehta.core.util.DeepaMehtaUtils.getRoleModels(DeepaMehtaUtils.java:179)
	at de.deepamehta.core.util.DeepaMehtaUtils.associationAutoTyping(DeepaMehtaUtils.java:163)
	at de.deepamehta.contacts.ContactsPlugin.preCreateAssociation(ContactsPlugin.java:59)
	at de.deepamehta.core.impl.CoreEvent$4.dispatch(CoreEvent.java:61)
	at de.deepamehta.core.impl.EventManager.dispatchEvent(EventManager.java:83)
	... 31 more

Apr 19, 2016 12:55:12 AM de.deepamehta.topicmaps.TopicmapsPlugin getTopicmap

Was there a breaking change that could explain the following exception?

Change History

comment:1 Changed 6 years ago by Malte

Using the URI to identify both players (which in this case exists for both topics) does not make a real difference:

INFORMATION: Sign-up => Assigning default "Sign-up Configuration" to "DeepaMehta 4 Sign up" Topic
Apr 19, 2016 1:06:04 AM de.deepamehta.core.impl.PluginImpl installPluginInDB
WARNUNG: ROLLBACK! (plugin "DeepaMehta 4 Sign up")
Apr 19, 2016 1:06:04 AM de.deepamehta.core.impl.PluginImpl$1 addingService
SCHWERWIEGEND: An error occurred while adding service de.deepamehta.workspaces.WorkspacesService to plugin "DeepaMehta 4 Sign up":
java.lang.RuntimeException: Activation of plugin "DeepaMehta 4 Sign up" failed
	at de.deepamehta.core.impl.PluginImpl.activate(PluginImpl.java:500)
	at de.deepamehta.core.impl.PluginManager.activatePlugin(PluginManager.java:64)
	at de.deepamehta.core.impl.PluginImpl.checkRequirementsForActivation(PluginImpl.java:464)
	at de.deepamehta.core.impl.PluginImpl.addService(PluginImpl.java:422)
	at de.deepamehta.core.impl.PluginImpl.access$000(PluginImpl.java:45)
	at de.deepamehta.core.impl.PluginImpl$1.addingService(PluginImpl.java:366)
	at org.osgi.util.tracker.ServiceTracker$Tracked.customizerAdding(ServiceTracker.java:932)
	at org.osgi.util.tracker.ServiceTracker$Tracked.customizerAdding(ServiceTracker.java:864)
	at org.osgi.util.tracker.AbstractTracked.trackAdding(AbstractTracked.java:256)
	at org.osgi.util.tracker.AbstractTracked.trackInitial(AbstractTracked.java:183)
	at org.osgi.util.tracker.ServiceTracker.open(ServiceTracker.java:317)
	at org.osgi.util.tracker.ServiceTracker.open(ServiceTracker.java:261)
	at de.deepamehta.core.impl.PluginImpl.openServiceTrackers(PluginImpl.java:395)
	at de.deepamehta.core.impl.PluginImpl.start(PluginImpl.java:120)
	at de.deepamehta.core.osgi.PluginActivator.start(PluginActivator.java:56)
	at org.apache.felix.framework.util.SecureAction.startActivator(SecureAction.java:645)
	at org.apache.felix.framework.Felix.activateBundle(Felix.java:2154)
	at org.apache.felix.framework.Felix.startBundle(Felix.java:2072)
	at org.apache.felix.framework.Felix.setActiveStartLevel(Felix.java:1299)
	at org.apache.felix.framework.FrameworkStartLevelImpl.run(FrameworkStartLevelImpl.java:304)
	at java.lang.Thread.run(Thread.java:745)
Caused by: java.lang.RuntimeException: Installing plugin "DeepaMehta 4 Sign up" in the database failed
	at de.deepamehta.core.impl.PluginImpl.installPluginInDB(PluginImpl.java:535)
	at de.deepamehta.core.impl.PluginImpl.activate(PluginImpl.java:487)
	... 20 more
Caused by: java.lang.RuntimeException: Running migration 2 of plugin "DeepaMehta 4 Sign up" failed
	at de.deepamehta.core.impl.MigrationManager.runMigration(MigrationManager.java:147)
	at de.deepamehta.core.impl.MigrationManager.runPluginMigration(MigrationManager.java:103)
	at de.deepamehta.core.impl.MigrationManager.runPluginMigrations(MigrationManager.java:70)
	at de.deepamehta.core.impl.PluginImpl.installPluginInDB(PluginImpl.java:525)
	... 21 more
Caused by: java.lang.RuntimeException: Creating association failed (association (id=-1, uri="null", typeUri="dm4.core.association", value="null", childTopics={}, 
        topic role (roleTypeUri="dm4.core.default", topicUri="org.deepamehta.sign-up"), 
        topic role (roleTypeUri="dm4.core.default", topicUri="org.deepamehta.signup.default_configuration")))
	at de.deepamehta.core.impl.PersistenceLayer.createAssociation(PersistenceLayer.java:302)
	at de.deepamehta.core.impl.CoreServiceImpl.createAssociation(CoreServiceImpl.java:196)
	at org.deepamehta.plugins.signup.migrations.Migration2.run(Migration2.java:33)
	at de.deepamehta.core.impl.MigrationManager.runMigration(MigrationManager.java:140)
	... 24 more
Caused by: java.lang.RuntimeException: An error occurred in the PreCreateAssociationListener of plugin "DeepaMehta 4 Contacts"
	at de.deepamehta.core.impl.EventManager.dispatchEvent(EventManager.java:96)
	at de.deepamehta.core.impl.EventManager.fireEvent(EventManager.java:59)
	at de.deepamehta.core.impl.PersistenceLayer.createAssociation(PersistenceLayer.java:290)
	... 27 more
Caused by: java.lang.IllegalStateException: The topic is not identified by ID but by URI (
        topic role (roleTypeUri="dm4.core.default", topicUri="org.deepamehta.sign-up"))
	at de.deepamehta.core.impl.TopicRoleModelImpl.getPlayerId(TopicRoleModelImpl.java:39)
	at de.deepamehta.core.util.DeepaMehtaUtils.getRoleModels(DeepaMehtaUtils.java:178)
	at de.deepamehta.core.util.DeepaMehtaUtils.associationAutoTyping(DeepaMehtaUtils.java:163)
	at de.deepamehta.contacts.ContactsPlugin.preCreateAssociation(ContactsPlugin.java:59)
	at de.deepamehta.core.impl.CoreEvent$4.dispatch(CoreEvent.java:61)
	at de.deepamehta.core.impl.EventManager.dispatchEvent(EventManager.java:83)
	... 29 more

Thankful for your support.

comment:2 Changed 6 years ago by Malte

  • Status changed from new to closed
  • Resolution set to worksforme

I see, just using the Topic ID seems to work and i guess i can understand the reasoning behind this change.
Closing ticket, loading the topic by Uri before creating an assoc works for me.

comment:3 Changed 6 years ago by jri

  • Priority changed from Minor to Major
  • Status changed from closed to reopened
  • Resolution worksforme deleted

Actually this breaking change is not intended. It's an error in DM 4.8 in conjunction with new Association Auto-Typing feature (#931).

A TopicRole? is supposed to be defined by-ID or by-URI, just like before DM 4.8. Your original code is supposed to work.

I'll try to fix this in DM 4.8.1

Thank you for reporting!

comment:4 Changed 6 years ago by jri

  • Version changed from 4.7 to 4.8
  • Milestone changed from Release 4.8 to Release 4.8.1

comment:5 Changed 5 years ago by Malte

This issue seems also to be in effect when one wants to introduce instances of assocations through a declarative migration. Doing so with 4.8.2 as the dm4-mail plugin does seems to be not longer possible.

Here an excerpt of the migration2.json:

    "associations": [
        { # associate configuration and plugin
            "type_uri": "dm4.core.association",
            "role_1": {
                "topic_uri": "de.deepamehta.mail",
                "role_type_uri": "dm4.core.default"
            },
            "role_2": {
               "topic_uri": "dm4.mail.config",
                "role_type_uri": "dm4.core.default"
            }
        }
    ]

And here the stacktrace from the failed installation:

Jul 09, 2016 12:16:26 AM de.deepamehta.core.impl.PluginImpl installPluginInDB
WARNUNG: ROLLBACK! (plugin "DeepaMehta 4 Mail")
Jul 09, 2016 12:16:26 AM de.deepamehta.core.impl.PluginImpl$1 addingService
SCHWERWIEGEND: An error occurred while adding service de.deepamehta.files.FilesService to plugin "DeepaMehta 4 Mail":
java.lang.RuntimeException: Activation of plugin "DeepaMehta 4 Mail" failed
	at de.deepamehta.core.impl.PluginImpl.activate(PluginImpl.java:500)
	at de.deepamehta.core.impl.PluginManager.activatePlugin(PluginManager.java:64)
	at de.deepamehta.core.impl.PluginImpl.checkRequirementsForActivation(PluginImpl.java:464)
	at de.deepamehta.core.impl.PluginImpl.addService(PluginImpl.java:422)
	at de.deepamehta.core.impl.PluginImpl.access$000(PluginImpl.java:45)
	at de.deepamehta.core.impl.PluginImpl$1.addingService(PluginImpl.java:366)
	at org.osgi.util.tracker.ServiceTracker$Tracked.customizerAdding(ServiceTracker.java:932)
	at org.osgi.util.tracker.ServiceTracker$Tracked.customizerAdding(ServiceTracker.java:864)
	at org.osgi.util.tracker.AbstractTracked.trackAdding(AbstractTracked.java:256)
	at org.osgi.util.tracker.AbstractTracked.trackInitial(AbstractTracked.java:183)
	at org.osgi.util.tracker.ServiceTracker.open(ServiceTracker.java:317)
	at org.osgi.util.tracker.ServiceTracker.open(ServiceTracker.java:261)
	at de.deepamehta.core.impl.PluginImpl.openServiceTrackers(PluginImpl.java:395)
	at de.deepamehta.core.impl.PluginImpl.start(PluginImpl.java:120)
	at de.deepamehta.core.osgi.PluginActivator.start(PluginActivator.java:56)
	at org.apache.felix.framework.util.SecureAction.startActivator(SecureAction.java:645)
	at org.apache.felix.framework.Felix.activateBundle(Felix.java:2154)
	at org.apache.felix.framework.Felix.startBundle(Felix.java:2072)
	at org.apache.felix.framework.Felix.setActiveStartLevel(Felix.java:1299)
	at org.apache.felix.framework.FrameworkStartLevelImpl.run(FrameworkStartLevelImpl.java:304)
	at java.lang.Thread.run(Thread.java:745)
Caused by: java.lang.RuntimeException: Installing plugin "DeepaMehta 4 Mail" in the database failed
	at de.deepamehta.core.impl.PluginImpl.installPluginInDB(PluginImpl.java:535)
	at de.deepamehta.core.impl.PluginImpl.activate(PluginImpl.java:487)
	... 20 more
Caused by: java.lang.RuntimeException: Running migration 2 of plugin "DeepaMehta 4 Mail" failed
	at de.deepamehta.core.impl.MigrationManager.runMigration(MigrationManager.java:147)
	at de.deepamehta.core.impl.MigrationManager.runPluginMigration(MigrationManager.java:103)
	at de.deepamehta.core.impl.MigrationManager.runPluginMigrations(MigrationManager.java:70)
	at de.deepamehta.core.impl.PluginImpl.installPluginInDB(PluginImpl.java:525)
	... 21 more
Caused by: java.lang.RuntimeException: Reading migration file "/migrations/migration2.json" failed
	at de.deepamehta.core.impl.MigrationManager.readMigrationFile(MigrationManager.java:195)
	at de.deepamehta.core.impl.MigrationManager.runMigration(MigrationManager.java:134)
	... 24 more
Caused by: java.lang.RuntimeException: Creating association failed (association (id=-1, uri="null", typeUri="dm4.core.association", value="null", childTopics={}, 
        topic role (roleTypeUri="dm4.core.default", topicUri="de.deepamehta.mail"), 
        topic role (roleTypeUri="dm4.core.default", topicUri="dm4.mail.config")))
	at de.deepamehta.core.impl.PersistenceLayer.createAssociation(PersistenceLayer.java:311)
	at de.deepamehta.core.impl.CoreServiceImpl.createAssociation(CoreServiceImpl.java:196)
	at de.deepamehta.core.impl.MigrationManager.createAssociations(MigrationManager.java:244)
	at de.deepamehta.core.impl.MigrationManager.readEntities(MigrationManager.java:220)
	at de.deepamehta.core.impl.MigrationManager.readMigrationFile(MigrationManager.java:188)
	... 25 more
Caused by: java.lang.RuntimeException: An error occurred in the PreCreateAssociationListener of plugin "DeepaMehta 4 Contacts"
	at de.deepamehta.core.impl.EventManager.dispatchEvent(EventManager.java:96)
	at de.deepamehta.core.impl.EventManager.fireEvent(EventManager.java:59)
	at de.deepamehta.core.impl.PersistenceLayer.createAssociation(PersistenceLayer.java:299)
	... 29 more
Caused by: java.lang.IllegalStateException: The topic is not identified by ID but by URI (
        topic role (roleTypeUri="dm4.core.default", topicUri="de.deepamehta.mail"))
	at de.deepamehta.core.impl.TopicRoleModelImpl.getPlayerId(TopicRoleModelImpl.java:39)
	at de.deepamehta.core.util.DeepaMehtaUtils.getRoleModels(DeepaMehtaUtils.java:178)
	at de.deepamehta.core.util.DeepaMehtaUtils.associationAutoTyping(DeepaMehtaUtils.java:163)
	at de.deepamehta.contacts.ContactsPlugin.preCreateAssociation(ContactsPlugin.java:59)
	at de.deepamehta.core.impl.CoreEvent$6.dispatch(CoreEvent.java:83)
	at de.deepamehta.core.impl.EventManager.dispatchEvent(EventManager.java:83)
	... 31 more

comment:6 Changed 5 years ago by jri

  • Milestone changed from Release 4.8.1 to Release 4.8.3

I will fix this very soon.
Please excuse the delay.

comment:7 Changed 5 years ago by Jörg Richter <jri@…>

In 6bcfa1521338ad99c6a8461ded43981447b3ace2/deepamehta:

Core: fix association auto-typing (#961).

When creating an association whith a topic player which is indentified by-URI no exception is thrown.

Note: association auto-typing is now supported only if both topic players are identified by-ID.

Thanks to Malte for reporting!

See #961.

comment:8 Changed 5 years ago by jri

  • Status changed from reopened to closed
  • Resolution set to fixed
Note: See TracTickets for help on using tickets.